Horizontal Violin in JavaScript

Using ApexCharts with JavaScript

This Horizontal Violin example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Build a Gaussian density profile + raw observations for a group.
// The sample template seeds Math.random, so this renders identically across reloads.
function gaussianViolin(mean, sd, n) {
  var density = []
  for (var v = mean - 3 * sd; v <= mean + 3 * sd; v += sd / 6) {
    var z = (v - mean) / sd
    density.push([Math.round(v * 10) / 10, Math.exp(-0.5 * z * z)])
  }
  var points = []
  for (var k = 0; k < n; k++) {
    // Box–Muller transform on two uniform samples
    var u1 = Math.random(),
      u2 = Math.random()
    var g = Math.sqrt(-2 * Math.log(u1)) * Math.cos(2 * Math.PI * u2)
    points.push(mean + g * sd)
  }
  return { density: density, points: points }
}

var options = {
  series: [
    {
      name: 'Latency',
      data: [
        { x: 'Auth', y: gaussianViolin(120, 18, 400) },
        { x: 'Search', y: gaussianViolin(210, 35, 500) },
        { x: 'Checkout', y: gaussianViolin(160, 22, 350) },
        { x: 'Recommend', y: gaussianViolin(260, 45, 300) },
      ],
    },
  ],
  chart: {
    type: 'violin',
    height: 460,
  },
  title: {
    text: 'Response time distribution by service (ms)',
  },
  plotOptions: {
    bar: {
      horizontal: true,
      distributed: true,
    },
    violin: {
      normalize: 'group',
      // dots in a darker shade of each violin's colour, no outline (strokeWidth: 0)
      points: { show: true, size: 3, jitter: 0.9, strokeWidth: 0 },
    },
  },
  colors: ['#14b8a6', '#3B82F6', '#f59e0b', '#ef4444'],
  stroke: { width: 1, colors: ['#888'] },
  legend: { show: false },
  xaxis: {
    title: { text: 'Response time (ms)' },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Horizontal Violin in Angular

Using ApexCharts with Angular

This Horizontal Violin example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private gaussianViolin = (mean: any, sd: any, n: any): any => {
          var density = []
          for (var v = mean - 3 * sd; v <= mean + 3 * sd; v += sd / 6) {
            var z = (v - mean) / sd
            density.push([Math.round(v * 10) / 10, Math.exp(-0.5 * z * z)])
          }
          var points = []
          for (var k = 0; k < n; k++) {
            // Box–Muller transform on two uniform samples
            var u1 = Math.random(),
              u2 = Math.random()
            var g = Math.sqrt(-2 * Math.log(u1)) * Math.cos(2 * Math.PI * u2)
            points.push(mean + g * sd)
          }
          return { density: density, points: points }
        };

  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Latency',
              data: [
                { x: 'Auth', y: this.gaussianViolin(120, 18, 400) },
                { x: 'Search', y: this.gaussianViolin(210, 35, 500) },
                { x: 'Checkout', y: this.gaussianViolin(160, 22, 350) },
                { x: 'Recommend', y: this.gaussianViolin(260, 45, 300) },
              ],
            },
          ],
          chart: {
            type: 'violin',
            height: 460,
          },
          title: {
            text: 'Response time distribution by service (ms)',
          },
          plotOptions: {
            bar: {
              horizontal: true,
              distributed: true,
            },
            violin: {
              normalize: 'group',
              // dots in a darker shade of each violin's colour, no outline (strokeWidth: 0)
              points: { show: true, size: 3, jitter: 0.9, strokeWidth: 0 },
            },
          },
          colors: ['#14b8a6', '#3B82F6', '#f59e0b', '#ef4444'],
          stroke: { width: 1, colors: ['#888'] },
          legend: { show: false },
          xaxis: {
            title: { text: 'Response time (ms)' },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Horizontal Violin in React

Using ApexCharts with React

This Horizontal Violin example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// Build a Gaussian density profile + raw observations for a group.
// The sample template seeds Math.random, so this renders identically across reloads.
function gaussianViolin(mean, sd, n) {
  var density = []
  for (var v = mean - 3 * sd; v <= mean + 3 * sd; v += sd / 6) {
    var z = (v - mean) / sd
    density.push([Math.round(v * 10) / 10, Math.exp(-0.5 * z * z)])
  }
  var points = []
  for (var k = 0; k < n; k++) {
    // Box–Muller transform on two uniform samples
    var u1 = Math.random(),
      u2 = Math.random()
    var g = Math.sqrt(-2 * Math.log(u1)) * Math.cos(2 * Math.PI * u2)
    points.push(mean + g * sd)
  }
  return { density: density, points: points }
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Latency',
        data: [
          { x: 'Auth', y: gaussianViolin(120, 18, 400) },
          { x: 'Search', y: gaussianViolin(210, 35, 500) },
          { x: 'Checkout', y: gaussianViolin(160, 22, 350) },
          { x: 'Recommend', y: gaussianViolin(260, 45, 300) },
        ],
      },
    ],
    options: {
      chart: {
        type: 'violin',
        height: 460,
      },
      title: {
        text: 'Response time distribution by service (ms)',
      },
      plotOptions: {
        bar: {
          horizontal: true,
          distributed: true,
        },
        violin: {
          normalize: 'group',
          // dots in a darker shade of each violin's colour, no outline (strokeWidth: 0)
          points: { show: true, size: 3, jitter: 0.9, strokeWidth: 0 },
        },
      },
      colors: ['#14b8a6', '#3B82F6', '#f59e0b', '#ef4444'],
      stroke: { width: 1, colors: ['#888'] },
      legend: { show: false },
      xaxis: {
        title: { text: 'Response time (ms)' },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="violin"
          height={460}
        />
      </div>
    </div>
  )
}

export default ApexChart

Horizontal Violin in Vue

Using ApexCharts with Vue

This Horizontal Violin example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="violin"
        height="460"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// Build a Gaussian density profile + raw observations for a group.
// The sample template seeds Math.random, so this renders identically across reloads.
function gaussianViolin(mean, sd, n) {
  var density = []
  for (var v = mean - 3 * sd; v <= mean + 3 * sd; v += sd / 6) {
    var z = (v - mean) / sd
    density.push([Math.round(v * 10) / 10, Math.exp(-0.5 * z * z)])
  }
  var points = []
  for (var k = 0; k < n; k++) {
    // Box–Muller transform on two uniform samples
    var u1 = Math.random(),
      u2 = Math.random()
    var g = Math.sqrt(-2 * Math.log(u1)) * Math.cos(2 * Math.PI * u2)
    points.push(mean + g * sd)
  }
  return { density: density, points: points }
}

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Latency',
          data: [
            { x: 'Auth', y: gaussianViolin(120, 18, 400) },
            { x: 'Search', y: gaussianViolin(210, 35, 500) },
            { x: 'Checkout', y: gaussianViolin(160, 22, 350) },
            { x: 'Recommend', y: gaussianViolin(260, 45, 300) },
          ],
        },
      ],
      chartOptions: {
        chart: {
          type: 'violin',
          height: 460,
        },
        title: {
          text: 'Response time distribution by service (ms)',
        },
        plotOptions: {
          bar: {
            horizontal: true,
            distributed: true,
          },
          violin: {
            normalize: 'group',
            // dots in a darker shade of each violin's colour, no outline (strokeWidth: 0)
            points: { show: true, size: 3, jitter: 0.9, strokeWidth: 0 },
          },
        },
        colors: ['#14b8a6', '#3B82F6', '#f59e0b', '#ef4444'],
        stroke: { width: 1, colors: ['#888'] },
        legend: { show: false },
        xaxis: {
          title: { text: 'Response time (ms)' },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 760px;
  margin: 20px auto;
}
</style>